#ifndef _DENSEMATRIX_H_
#define _DENSEMATRIX_H_


// Beispiele dichtbesetzter Matrizen 
#include <iostream>
using namespace std;
#include <cstdlib>

void zweimalzwei(double* A,double* b)
// LGS
//       A=[eps 1]   b=[3/4+eps,3/2+eps/4]
//         [ 1  1]   
{
  double eins,eps;
    eins=1.;
    vdcopy(3,&A[1],1,&eins,0);
    eps=pow(2.,-64);
    A[0]=eps;
    b[0]=3./4.+eps;
    b[1]=3./2.+eps/4.; 
}

void hilbert(double* A,double* b,int n)
// LGS Hilbertmatrix
// Bestimme das Polynom p(x)=a_{n-1} x^{n-1} +.. +a_0 aus P_{n-1} mit 
// int_0^1 (p(x)-e^x)^2 dx 
// ist minimal
{
  double* h;
  int k,i;
  h=(double*)malloc((10*n)*sizeof(double));
  for (i=0;i<2*n-1;i++) 
    {
      h[i]=1./double(i+1.);
    }
  for (i=0;i<n;i++) 
    {
      vdcopy(n,&A[n*i],1,&h[i],1);
    }
  h[10*n-1]=2.;
  for (i=10*n-2;i>-1;i--)
    {
      h[i]=1./double(i+1)*(1-h[i+1]);
    }
  vdcopy(n,b,1,h,1);
  free(h);
}

void vandermonde(double* A,double* y,int n)
// Berechnet zu y die Vandermondematrix
{
  double eins;
  int k,i;
  eins=1.;
  vdcopy(n,A,n,&eins,0);
  for (i=1;i<n;i++) 
    {
      vdmult(n,&A[i-1],n,y,1,&A[i],n);
    }
}




#endif
